/* ******************************************************************
 * Name based handling of colors:
 *   fromName  converts a String to a Color
 *   toString  converts a Color to a String 
 * Both routines try to map to/from a color name, otherwise a RGB 
 * representaion in the form <java.awt.Color>[r=nnn,g=nnn,b=nnn] is used. 
 *
 *   version  who    when      what 
 *     1.0    se     291098    First version
 */
import java.awt.*;

public class MyColor
{
  public static Color fromName( String name ) {
    if( name.equals( "black" )     ) return Color.black;
    if( name.equals( "blue" )      ) return Color.blue;
    if( name.equals( "cyan" )      ) return Color.cyan;
    if( name.equals( "darkGray" )  ) return Color.darkGray;
    if( name.equals( "gray" )      ) return Color.gray;
    if( name.equals( "green" )     ) return Color.green;
    if( name.equals( "lightGray" ) ) return Color.lightGray;
    if( name.equals( "magenta" )   ) return Color.magenta;
    if( name.equals( "orange" )    ) return Color.orange;
    if( name.equals( "pink" )      ) return Color.pink;
    if( name.equals( "red" )       ) return Color.red;
    if( name.equals( "white" )     ) return Color.white;
    if( name.equals( "yellow" )    ) return Color.yellow;
    if( name.startsWith( "java.awt.Color[" ) || name.startsWith( "[r=" ) ) {
      System.out.println("interpreting " + name );
      int red, green, blue;
      String num;
      num = name.substring( name.indexOf( "r=" )+2, name.indexOf(",g" ) );
      red = Integer.valueOf( num ).intValue();
      num = name.substring( name.indexOf( "g=" )+2, name.indexOf(",b" ) );
      green = Integer.valueOf( num ).intValue();
      num = name.substring( name.indexOf( "b=" )+2, name.indexOf("]" ) );
      blue = Integer.valueOf( num ).intValue();
      return new Color( red, green, blue );
    }
    return null;
  }

  public static String toString( Color c ) {
    if( c.equals( Color.black )     ) return "black";
    if( c.equals( Color.blue )      ) return "blue";
    if( c.equals( Color.cyan  )     ) return "cyan";
    if( c.equals( Color.darkGray )  ) return "darkGray";
    if( c.equals( Color.gray   )    ) return "gray";
    if( c.equals( Color.green )     ) return "green";
    if( c.equals( Color.lightGray ) ) return "lightGray";
    if( c.equals( Color.magenta   ) ) return "magenta";
    if( c.equals( Color.orange  )   ) return "orange";
    if( c.equals( Color.pink )      ) return "pink";
    if( c.equals( Color.red )       ) return "red";
    if( c.equals( Color.white )     ) return "white";
    if( c.equals( Color.yellow )    ) return "yellow";
    return c.toString();
  }
}
